package com.sun.jmx.snmp.defaults;

import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.File;

public class DefaultPaths
{
    private static final String INSTALL_PATH_RESOURCE_NAME = "com/sun/jdmk/defaults/install.path";
    private static String etcDir;
    private static String tmpDir;
    private static String installDir;
    
    private DefaultPaths() {
    }
    
    public static String getInstallDir() {
        if (DefaultPaths.installDir == null) {
            return useRessourceFile();
        }
        return DefaultPaths.installDir;
    }
    
    public static String getInstallDir(String s) {
        if (DefaultPaths.installDir == null) {
            if (s == null) {
                return getInstallDir();
            }
            return getInstallDir() + File.separator + s;
        }
        else {
            if (s == null) {
                return DefaultPaths.installDir;
            }
            return DefaultPaths.installDir + File.separator + s;
        }
    }
    
    public static void setInstallDir(String installDir) {
        DefaultPaths.installDir = installDir;
    }
    
    public static String getEtcDir() {
        if (DefaultPaths.etcDir == null) {
            return getInstallDir("etc");
        }
        return DefaultPaths.etcDir;
    }
    
    public static String getEtcDir(String s) {
        if (DefaultPaths.etcDir == null) {
            if (s == null) {
                return getEtcDir();
            }
            return getEtcDir() + File.separator + s;
        }
        else {
            if (s == null) {
                return DefaultPaths.etcDir;
            }
            return DefaultPaths.etcDir + File.separator + s;
        }
    }
    
    public static void setEtcDir(String etcDir) {
        DefaultPaths.etcDir = etcDir;
    }
    
    public static String getTmpDir() {
        if (DefaultPaths.tmpDir == null) {
            return getInstallDir("tmp");
        }
        return DefaultPaths.tmpDir;
    }
    
    public static String getTmpDir(String s) {
        if (DefaultPaths.tmpDir == null) {
            if (s == null) {
                return getTmpDir();
            }
            return getTmpDir() + File.separator + s;
        }
        else {
            if (s == null) {
                return DefaultPaths.tmpDir;
            }
            return DefaultPaths.tmpDir + File.separator + s;
        }
    }
    
    public static void setTmpDir(String tmpDir) {
        DefaultPaths.tmpDir = tmpDir;
    }
    
    private static String useRessourceFile() {
        InputStream resourceAsStream = null;
        BufferedReader bufferedReader = null;
        try {
            resourceAsStream = DefaultPaths.class.getClassLoader().getResourceAsStream("com/sun/jdmk/defaults/install.path");
            if (resourceAsStream == null) {
                return null;
            }
            bufferedReader = new BufferedReader(new InputStreamReader(resourceAsStream));
            DefaultPaths.installDir = bufferedReader.readLine();
        }
        catch (Exception ex) {}
        finally {
            try {
                if (resourceAsStream != null) {
                    resourceAsStream.close();
                }
                if (bufferedReader != null) {
                    bufferedReader.close();
                }
            }
            catch (Exception ex2) {}
        }
        return DefaultPaths.installDir;
    }
}
